//Source file: C:\\sw_dev\\chat\\ServerDeChat_v1.java

/**
 * Server chat simplu - componenta server pentru noi conexiuni
 */
import java.net.*;
import java.io.*;
import java.util.*;

public class ServerDeChat_v1 {
  private TratareClientDeChat_v1 firTratare;
  private Socket socket;
  
  /**
   * @param port
   * @throws java.io.IOException
   */
  public ServerDeChat_v1(int port) throws IOException {

    // Server pentru asteptarea cererilor de conectare
    ServerSocket server = new ServerSocket (port);
    System.out.println ("Server TCP lansat pe port " + port  + "...");

    // Bucla infinita
    while (true) {

      // Asteptarea cererilor de conectare si returnarea unui nou socket
      Socket client = server.accept ();
      System.out.println ("Acceptata conexiunea de la: [" + client.getInetAddress()
                            + ":" + client.getPort() + "]...");
      System.out.println ("pe portul local: " + client.getLocalPort());

      // Crearea unui fir de executie pentru tratare client nou
      firTratare = new TratareClientDeChat_v1 (client); 

      // Lansarea firului de executie - se va executa: firTratare.run()
      firTratare.start ();		                 
     }   
  }
  
  /**
   * @param args
   * @throws java.io.IOException
   */
  public static void main(java.lang.String[] args) throws IOException {

    if (args.length != 1)
      throw new RuntimeException ("Sintaxa: ServerDeChat_v1 <numarPort>");

    new ServerDeChat_v1 (Integer.parseInt (args[0]));   
  }
}
